import _CodeMirror from "codemirror";
import type { App } from "vue";
import type { EditorConfiguration, Editor } from "codemirror";
import VueCodemirror from "./src/components/index.vue";
interface CmComp {
    cminstance: Editor;
    resize: (width?: string | number | null, height?: string | number | null) => void;
    refresh: () => void;
    destroy: () => void;
}
export declare type CmComponentRef = CmComp | null;
declare interface InstallConfig {
    options: EditorConfiguration;
    componentName: string;
}
declare const CodeMirror: typeof _CodeMirror;
/**
 * Use global components.
 * @example
 * import { createApp } from "vue";
 * const app = createApp(App);
 * app.use(GlobalCmComponent, { componentName: "customCodemirrorComponentName" });
 */
declare const GlobalCmComponent: (app: App, config?: InstallConfig | undefined) => App<any>;
export * from "./src/components/presetMode/log/utils";
export { CodeMirror, GlobalCmComponent, VueCodemirror };
export default VueCodemirror;
