import type { Ref } from "vue";
import type { Editor } from "codemirror";
import type { MergeView } from "codemirror/addon/merge/merge";
import type { CmProps } from '../..src/types/props';
export declare type UseViewControlParams = {
    props: CmProps;
    cminstance: Ref<Nullable<Editor | MergeView>>;
    presetRef: Ref<Nullable<{
        initialize: () => void;
    }>>;
};
export declare function useViewControl({ props, cminstance, presetRef, }: UseViewControlParams): {
    reload: () => void;
    refresh: () => void;
    resize: (width?: string | number | null, height?: string | number | null) => void;
    destroy: () => void;
    containerHeight: Ref<Nullable<string>>;
    reviseStyle: () => void;
};
